#include "stdafx.h"
#include "TCLegendTest.h"
#include "TCLegendTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define MARGIN          10
#define BTN_WIDTH       75
#define BTN_HEIGHT      25
#define HALF_BTN_WIDTH  (BTN_WIDTH / 2)
#define QTR_BTN_WIDTH   (BTN_WIDTH / 4)

void CTCLegendTestDlg::OnSize(UINT nType, int cx, int cy)
{
    CRect r;
    CString str;
    bool align = true;
    int ph = (cy - BTN_HEIGHT - (MARGIN * 5)) / 3;

    CDialog::OnSize(nType, cx, cy);

    r.top = cy - MARGIN - BTN_HEIGHT;
    r.bottom = r.top + BTN_HEIGHT;

    // Left Justified

    if(IsWindow(m_btnTop.GetSafeHwnd()))
    {
        r.left = MARGIN;
        r.right = r.left + HALF_BTN_WIDTH;

        m_btnTop.MoveWindow(r);
        m_btnTop.Invalidate();
    }

    if(IsWindow(m_btnBottom.GetSafeHwnd()))
    {
        r.left = (MARGIN * 2) + HALF_BTN_WIDTH;
        r.right = r.left + HALF_BTN_WIDTH;

        m_btnBottom.MoveWindow(r);
        m_btnBottom.Invalidate();
    }

    if(IsWindow(m_btnLeft.GetSafeHwnd()))
    {
        r.left = (MARGIN * 4) + (HALF_BTN_WIDTH * 2);
        r.right = r.left + HALF_BTN_WIDTH;

        m_btnLeft.MoveWindow(r);
        m_btnLeft.Invalidate();
    }

    if(IsWindow(m_btnRight.GetSafeHwnd()))
    {
        r.left = (MARGIN * 5) + (HALF_BTN_WIDTH * 3);
        r.right = r.left + HALF_BTN_WIDTH;

        m_btnRight.MoveWindow(r);
        m_btnRight.Invalidate();
    }

    if(IsWindow(m_btnInt.GetSafeHwnd()))
    {
        r.left = (MARGIN * 7) + (HALF_BTN_WIDTH * 4);
        r.right = r.left + HALF_BTN_WIDTH;

        m_btnInt.MoveWindow(r);
        m_btnInt.Invalidate();
    }

    if(IsWindow(m_btnExt.GetSafeHwnd()))
    {
        r.left = (MARGIN * 8) + (HALF_BTN_WIDTH * 5);
        r.right = r.left + HALF_BTN_WIDTH;

        m_btnExt.MoveWindow(r);
        m_btnExt.Invalidate();
    }

    if(IsWindow(m_edtX.GetSafeHwnd()))
    {
        r.left = (MARGIN * 10) + (HALF_BTN_WIDTH * 6);
        r.right = r.left + HALF_BTN_WIDTH;

        m_edtX.MoveWindow(r);
        m_edtX.Invalidate();
    }

    if(IsWindow(m_spnX.GetSafeHwnd()))
    {
        r.left = r.right + 1;
        r.right = r.left + QTR_BTN_WIDTH;

        m_spnX.MoveWindow(r);
        m_spnX.Invalidate();
    }

    if(IsWindow(m_edtY.GetSafeHwnd()))
    {
        r.left = (MARGIN * 11) + (HALF_BTN_WIDTH * 7) + QTR_BTN_WIDTH + 1;
        r.right = r.left + HALF_BTN_WIDTH;

        m_edtY.MoveWindow(r);
        m_edtY.Invalidate();
    }

    if(IsWindow(m_spnY.GetSafeHwnd()))
    {
        r.left = r.right + 1;
        r.right = r.left + QTR_BTN_WIDTH;

        m_spnY.MoveWindow(r);
        m_spnY.Invalidate();
    }

    if(IsWindow(m_chkAlign.GetSafeHwnd()))
    {
        r.left = (MARGIN * 13) + (HALF_BTN_WIDTH * 8) + (QTR_BTN_WIDTH * 2) + 2;
        r.right = r.left + BTN_WIDTH;

        m_chkAlign.MoveWindow(r);
        m_chkAlign.Invalidate();
    }

    // Right Justified

    if(IsWindow(m_btnSettings.GetSafeHwnd()))
    {
        r.left = cx - ((MARGIN + BTN_WIDTH) * 2);
        r.right = r.left + BTN_WIDTH;

        m_btnSettings.MoveWindow(r);
        m_btnSettings.Invalidate();
    }

    if(IsWindow(m_btnQuit.GetSafeHwnd()))
    {
        r.left = cx - MARGIN - BTN_WIDTH;
        r.right = r.left + BTN_WIDTH;

        m_btnQuit.MoveWindow(r);
        m_btnQuit.Invalidate();
    }

    // Plots

    if(!m_sizing)
    {
        if(IsWindow(m_topPlot.GetSafeHwnd()))
        {
            r.top = r.left = MARGIN;
            r.right = cx - MARGIN;
            r.bottom = r.top + ph;

            m_topPlot.MoveWindow(r);
        }
        else align = false;

        if(IsWindow(m_midPlot.GetSafeHwnd()))
        {
            r.top = ph + (MARGIN * 2);
            r.left = MARGIN;
            r.right = cx - MARGIN;
            r.bottom = r.top + ph;

            m_midPlot.MoveWindow(r);
        }
        else align = false;

        if(IsWindow(m_btmPlot.GetSafeHwnd()))
        {
            r.top = (ph * 2) + (MARGIN * 3);
            r.left = MARGIN;
            r.right = cx - MARGIN;
            r.bottom = r.top + ph;

            m_btmPlot.MoveWindow(r);
        }
        else align = false;

        if(align) AlignPlots();
    }
}

void CTCLegendTestDlg::OnEnterSizeMove()
{
    m_sizing = true;
    m_topPlot.ShowWindow(SW_HIDE);
    m_midPlot.ShowWindow(SW_HIDE);
    m_btmPlot.ShowWindow(SW_HIDE);

    CDialog::OnEnterSizeMove();
}

void CTCLegendTestDlg::OnExitSizeMove()
{
    CRect r;

    CDialog::OnExitSizeMove();

    m_sizing = false;
    m_topPlot.ShowWindow(SW_SHOW);
    m_midPlot.ShowWindow(SW_SHOW);
    m_btmPlot.ShowWindow(SW_SHOW);

    // This triggers an OnSize call.
    GetWindowRect(&r);
    r.DeflateRect(1, 1);
    MoveWindow(r);
}

void CTCLegendTestDlg::OnBnClickedButtonTop()
{
    CURRENTSETTINGS()->m_bTop = true;
}

void CTCLegendTestDlg::OnBnClickedButtonBottom()
{
    CURRENTSETTINGS()->m_bTop = false;
}

void CTCLegendTestDlg::OnBnClickedButtonLeft()
{
    CURRENTSETTINGS()->m_bRight = false;
}

void CTCLegendTestDlg::OnBnClickedButtonRight()
{
    CURRENTSETTINGS()->m_bRight = true;
}

void CTCLegendTestDlg::OnBnClickedButtonInternal()
{
    CURRENTSETTINGS()->m_bInt = true;
}

void CTCLegendTestDlg::OnBnClickedButtonExternal()
{
    CURRENTSETTINGS()->m_bInt = false;
}

void CTCLegendTestDlg::OnBnClickedButtonAlign()
{
    m_alignEnabled = (m_chkAlign.GetCheck() == BST_CHECKED);
    AlignPlots();
}

void CTCLegendTestDlg::OnBnClickedButtonSettings()
{
    CURRENTPLOT()->ShowEditor(-1);
}

void CTCLegendTestDlg::OnBnClickedButtonQuit()
{
    CDialog::OnOK();
}

LRESULT CTCLegendTestDlg::OnKickIdle(WPARAM wParam, LPARAM lParam)
{
    CRect r;
    CString str;
    static bool first = true;

    if(first)
    {
        GetWindowRect(&r);
        r.DeflateRect(1, 1);
        MoveWindow(r);
        first = false;
    }

    return FALSE;
}