#include "stdafx.h"
#include "math.h"
#include "TCLegendTest.h"
#include "TCLegendTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CTCLegendTestDlg::CTCLegendTestDlg(CWnd* pParent)
	: CDialog(CTCLegendTestDlg::IDD, pParent)
{
    m_sizing = false;
    m_alignEnabled = false;
    m_curPlot = &m_topPlot;
    m_psCurrent = &m_psTop;
}

CTCLegendTestDlg::~CTCLegendTestDlg(void)
{
}

void CTCLegendTestDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_X, m_strXOff);
	DDX_Text(pDX, IDC_EDIT_Y, m_strYOff);
    DDX_Control(pDX, IDC_PLOT_TOP, m_topPlot);
    DDX_Control(pDX, IDC_PLOT_MIDDLE, m_midPlot);
    DDX_Control(pDX, IDC_PLOT_BOTTOM, m_btmPlot);
    DDX_Control(pDX, IDC_EDIT_X, m_edtX);
    DDX_Control(pDX, IDC_EDIT_Y, m_edtY);
    DDX_Control(pDX, IDC_RADIO_TOP, m_btnTop);
    DDX_Control(pDX, IDC_RADIO_BOTTOM, m_btnBottom);
    DDX_Control(pDX, IDC_RADIO_LEFT, m_btnLeft);
    DDX_Control(pDX, IDC_RADIO_RIGHT, m_btnRight);
    DDX_Control(pDX, IDC_RADIO_INTERNAL, m_btnInt);
    DDX_Control(pDX, IDC_RADIO_EXTERNAL, m_btnExt);
    DDX_Control(pDX, IDC_CHECK_ALIGN, m_chkAlign);
    DDX_Control(pDX, IDC_BUTTON_SETTINGS, m_btnSettings);
    DDX_Control(pDX, IDC_BUTTON_QUIT, m_btnQuit);
    DDX_Control(pDX, IDC_SPIN_X, m_spnX);
    DDX_Control(pDX, IDC_SPIN_Y, m_spnY);
}

BEGIN_MESSAGE_MAP(CTCLegendTestDlg, CDialog)
    ON_WM_SIZE()
    ON_WM_ENTERSIZEMOVE()
    ON_WM_EXITSIZEMOVE()
	ON_MESSAGE(WM_KICKIDLE, &CTCLegendTestDlg::OnKickIdle)
    ON_BN_CLICKED(IDC_RADIO_TOP, &CTCLegendTestDlg::OnBnClickedButtonTop)
    ON_BN_CLICKED(IDC_RADIO_BOTTOM, &CTCLegendTestDlg::OnBnClickedButtonBottom)
    ON_BN_CLICKED(IDC_RADIO_LEFT, &CTCLegendTestDlg::OnBnClickedButtonLeft)
    ON_BN_CLICKED(IDC_RADIO_RIGHT, &CTCLegendTestDlg::OnBnClickedButtonRight)
    ON_BN_CLICKED(IDC_RADIO_INTERNAL, &CTCLegendTestDlg::OnBnClickedButtonInternal)
    ON_BN_CLICKED(IDC_RADIO_EXTERNAL, &CTCLegendTestDlg::OnBnClickedButtonExternal)
    ON_BN_CLICKED(IDC_CHECK_ALIGN, &CTCLegendTestDlg::OnBnClickedButtonAlign)
    ON_BN_CLICKED(IDC_BUTTON_SETTINGS, &CTCLegendTestDlg::OnBnClickedButtonSettings)
    ON_BN_CLICKED(IDC_BUTTON_QUIT, &CTCLegendTestDlg::OnBnClickedButtonQuit)
END_MESSAGE_MAP()

BEGIN_EVENTSINK_MAP(CTCLegendTestDlg, CDialog)
    ON_EVENT_RANGE(CTCLegendTestDlg, IDC_PLOT_TOP, IDC_PLOT_BOTTOM, 19, CTCLegendTestDlg::OnMouseDown, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4)
END_EVENTSINK_MAP()

// CTCLegendTestDlg message handlers

BOOL CTCLegendTestDlg::OnInitDialog()
{
    CSeries s;
    long i, sz;
    CValueList vl;
	CDialog::OnInitDialog();

    m_edtX.EnableWindow(FALSE);
    m_edtY.EnableWindow(FALSE);
    m_btnTop.EnableWindow(FALSE);
    m_btnBottom.EnableWindow(FALSE);
    m_btnLeft.EnableWindow(FALSE);
    m_btnRight.EnableWindow(FALSE);
    m_btnInt.EnableWindow(FALSE);
    m_btnExt.EnableWindow(FALSE);
    m_spnX.EnableWindow(FALSE);
    m_spnY.EnableWindow(FALSE);

    m_topPlot.GetAspect().SetView3D(FALSE);
    m_topPlot.Series(m_topPlot.AddSeries(scLine)).FillSampleValues(1000);
    m_midPlot.GetAspect().SetView3D(FALSE);
    m_midPlot.Series(m_midPlot.AddSeries(scLine)).FillSampleValues(1000);
    m_btmPlot.GetAspect().SetView3D(FALSE);
    s = m_btmPlot.Series(m_btmPlot.AddSeries(scLine));
    s.FillSampleValues(1000);

    m_topPlot.GetAxis().GetLeft().SetVisible(FALSE);
    m_midPlot.GetLegend().SetVisible(FALSE);
    vl = s.GetYValues();
    sz = vl.GetCount();
    for(i = 0; i < sz; i++)
        s.SetPointValue(i, vl.GetValue(i) + 1000.0);

	m_topPlot.GetPanel().GetGradient().SetVisible(FALSE);
	m_topPlot.GetWalls().GetBack().SetTransparent(TRUE);
	m_midPlot.GetPanel().GetGradient().SetVisible(FALSE);
	m_midPlot.GetWalls().GetBack().SetTransparent(TRUE);
	m_btmPlot.GetPanel().GetGradient().SetVisible(FALSE);
	m_btmPlot.GetWalls().GetBack().SetTransparent(TRUE);

    m_chkAlign.SetCheck(m_alignEnabled ? BST_CHECKED : BST_UNCHECKED);

    CheckRadioButton(IDC_RADIO_INTERNAL, IDC_RADIO_EXTERNAL,
        m_psCurrent->m_bInt ? IDC_RADIO_INTERNAL : IDC_RADIO_EXTERNAL);
    CheckRadioButton(IDC_RADIO_TOP, IDC_RADIO_BOTTOM,
        m_psCurrent->m_bTop ? IDC_RADIO_TOP : IDC_RADIO_BOTTOM);
    CheckRadioButton(IDC_RADIO_LEFT, IDC_RADIO_RIGHT,
        m_psCurrent->m_bRight ? IDC_RADIO_RIGHT : IDC_RADIO_LEFT);

    m_topPlot.GetPanel().SetColor(RGB(255, 255, 255));
    m_midPlot.GetPanel().SetColor(RGB(255, 255, 255));
    m_btmPlot.GetPanel().SetColor(RGB(255, 255, 255));
    CURRENTPLOT()->GetPanel().SetColor(RGB(240, 210, 210));

	return TRUE;
}

void CTCLegendTestDlg::OnMouseDown(UINT plotID, long Button, long Shift, long X, long Y)
{
    CURRENTPLOT()->GetPanel().SetColor(RGB(255, 255, 255));

    switch(plotID)
    {
        case IDC_PLOT_TOP:      m_curPlot = &m_topPlot;     m_psCurrent = &m_psTop;     break;
        case IDC_PLOT_MIDDLE:   m_curPlot = &m_midPlot;     m_psCurrent = &m_psMid;     break;
        case IDC_PLOT_BOTTOM:   m_curPlot = &m_btmPlot;     m_psCurrent = &m_psBtm;     break;
        
        default:    m_curPlot = NULL;   m_psCurrent = NULL;     break;
    }

    CURRENTPLOT()->GetPanel().SetColor(RGB(240, 210, 210));
}

void CTCLegendTestDlg::AlignPlots(void)
{
    CString str;
    CTeeRect tr, mr, br;
    long left = 0, right = 99999;

    m_topPlot.SetCustomChartRect(FALSE);
    m_midPlot.SetCustomChartRect(FALSE);
    m_btmPlot.SetCustomChartRect(FALSE);
    m_topPlot.Repaint();
    m_midPlot.Repaint();
    m_btmPlot.Repaint();

    if(m_alignEnabled)
    {
        tr = m_topPlot.GetGetChartRect();
        if(tr.GetLeft() > left) left = tr.GetLeft();
        if(tr.GetRight() < right) right = tr.GetRight();

        mr = m_midPlot.GetGetChartRect();
        if(mr.GetLeft() > left) left = mr.GetLeft();
        if(mr.GetRight() < right) right = mr.GetRight();

        br = m_btmPlot.GetGetChartRect();
        if(br.GetLeft() > left) left = br.GetLeft();
        if(br.GetRight() < right) right = br.GetRight();

        m_topPlot.SetCustomChartRect(TRUE);
        m_topPlot.ChartRect(left, tr.GetTop(), right, tr.GetBottom());
        m_topPlot.Repaint();

        m_midPlot.SetCustomChartRect(TRUE);
        m_midPlot.ChartRect(left, mr.GetTop(), right, mr.GetBottom());
        m_midPlot.Repaint();

        m_btmPlot.SetCustomChartRect(TRUE);
        m_btmPlot.ChartRect(left, br.GetTop(), right, br.GetBottom());
        m_btmPlot.Repaint();
    }
}
        
void CTCLegendTestDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	__super::OnVScroll(nSBCode, nPos, pScrollBar);
}