#pragma once
#include "TChartHeaders.h"
#include "afxwin.h"
#include "afxcmn.h"

#define CURRENTPLOT()       (m_curPlot != NULL ? m_curPlot : &m_blankPlot)
#define CURRENTSETTINGS()   (m_psCurrent != NULL ? m_psCurrent : &m_psBlank)

typedef struct PlotSettingsStruct
{
    long m_nXOff, m_nYOff;
    bool m_bTop, m_bRight, m_bInt;

    void PlotSettings(void)
    {
        m_nXOff = m_nYOff = 2;
        m_bTop =  m_bRight = m_bInt = true;
    }

} PlotSettings, *PlotSettingsPtr;

class CTCLegendTestDlg : public CDialog
{
    private:

	    enum { IDD = IDD_TCPOINTTEST_DIALOG };

        PlotSettings m_psTop, m_psMid, m_psBtm, m_psBlank;

        CTChart *m_curPlot;
        PlotSettingsPtr m_psCurrent;

        CString m_strXOff, m_strYOff;
        bool m_sizing, m_alignEnabled;

    protected:

        CTChart m_topPlot;
        CTChart m_midPlot;
        CTChart m_btmPlot;
        CTChart m_blankPlot;

        CEdit m_edtX;
        CEdit m_edtY;
        CButton m_btnTop;
        CButton m_btnBottom;
        CButton m_btnLeft;
        CButton m_btnRight;
        CButton m_btnInt;
        CButton m_btnExt;
        CSpinButtonCtrl m_spnX;
        CSpinButtonCtrl m_spnY;
        CButton m_chkAlign;
        CButton m_btnSettings;
        CButton m_btnQuit;

	    virtual BOOL OnInitDialog();
        virtual void OnOK() {}
        virtual void OnCancel() {}
	    virtual void DoDataExchange(CDataExchange* pDX);

        afx_msg void OnSize(UINT nType, int cx, int cy);
        afx_msg void OnEnterSizeMove();
        afx_msg void OnExitSizeMove();
        afx_msg void OnEnChangeEditX();
        afx_msg void OnEnChangeEditY();
        afx_msg void OnBnClickedButtonTop();
        afx_msg void OnBnClickedButtonBottom();
        afx_msg void OnBnClickedButtonLeft();
        afx_msg void OnBnClickedButtonRight();
        afx_msg void OnBnClickedButtonInternal();
        afx_msg void OnBnClickedButtonExternal();
        afx_msg void OnBnClickedButtonAlign();
        afx_msg void OnBnClickedButtonSettings();
        afx_msg void OnBnClickedButtonQuit();
        afx_msg LRESULT OnKickIdle(WPARAM wParam, LPARAM lParam);
	    afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);

        void OnGetLegendRect(UINT plotID, long* Left, long* Top, long* Right, long* Bottom);
        void OnMouseDown(UINT plotID, long Button, long Shift, long X, long Y);

        void AlignPlots(void);

    public:

	    CTCLegendTestDlg(CWnd* pParent = NULL);
	    ~CTCLegendTestDlg(void);

	DECLARE_MESSAGE_MAP()
    DECLARE_EVENTSINK_MAP()
};
